// Unreal Fighting Framework by Kevin Poretti

#include "FFInputBufferComponent.h"

UFFInputBufferComponent::UFFInputBufferComponent()
{
	PrimaryComponentTick.bCanEverTick = false;
}

void UFFInputBufferComponent::AddInput(const FFFInputState& InputState)
{
	InputBuffer.ForcePush(InputState);
}

bool UFFInputBufferComponent::CheckInputSequence(const FFFInputCondition& InputCondition)
{
    int CondIdx = InputCondition.Sequence.Num() - 1;
    int FramesSinceValidInput = 0;
    for(int InpIdx = 0; InpIdx < InputBuffer.Num(); InpIdx++)
    {
        int32 CurrCondition = InputCondition.Sequence[CondIdx].Buttons;
        int32 ThisInput = InputBuffer[InpIdx].Buttons;
        if(ThisInput & CurrCondition)
        {
            CondIdx--;
            FramesSinceValidInput = 0;
        }

        // All conditions were met
        if(CondIdx == -1)
        {
            return true;
        }

        FramesSinceValidInput++;
        if(FramesSinceValidInput > InputCondition.Lenience)
        {
            return false;
        }
    }

	return false;
}
